

// This C++ file was created by SanEditor

#include "Atomic/computer/computerSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         computerSAN Constructor             
******************************************************************/


computerSAN::computerSAN(){


  Activity* InitialActionList[4]={
    &arrival, //0
    &completion, //1
    &busy_fail, //2
    &idle_fail  // 3
  };

  BaseGroupClass* InitialGroupList[4]={
    (BaseGroupClass*) &(arrival), 
    (BaseGroupClass*) &(completion), 
    (BaseGroupClass*) &(busy_fail), 
    (BaseGroupClass*) &(idle_fail)
  };

  idle = new Place("idle" ,1);
  busy = new Place("busy" ,0);
  failed = new Place("failed" ,0);
  BaseStateVariableClass* InitialPlaces[3]={
    idle,  // 0
    busy,  // 1
    failed   // 2
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("computer", 3, InitialPlaces, 
                        0, InitialROPlaces, 
                        4, InitialActionList, 4, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[8][2]={ 
    {0,0}, {1,0}, {1,1}, {0,1}, {1,2}, {2,2}, {0,3}, {2,3}
  };
  for(int n=0;n<8;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[4][2]={ 
    {0,0}, {1,1}, {1,2}, {0,3}
  };
  for(int n=0;n<4;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<4;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void computerSAN::CustomInitialization() {

}
computerSAN::~computerSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void computerSAN::assignPlacesToActivitiesInst(){
}
void computerSAN::assignPlacesToActivitiesTimed(){
  arrival.idle = (Place*) LocalStateVariables[0];
  arrival.busy = (Place*) LocalStateVariables[1];
  completion.busy = (Place*) LocalStateVariables[1];
  completion.idle = (Place*) LocalStateVariables[0];
  busy_fail.busy = (Place*) LocalStateVariables[1];
  busy_fail.failed = (Place*) LocalStateVariables[2];
  idle_fail.idle = (Place*) LocalStateVariables[0];
  idle_fail.failed = (Place*) LocalStateVariables[2];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================arrivalActivity========================*/

computerSAN::arrivalActivity::arrivalActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("arrival",0,Exponential, RaceEnabled, 2,1, false);
}

computerSAN::arrivalActivity::~arrivalActivity(){
  delete[] TheDistributionParameters;
}

void computerSAN::arrivalActivity::LinkVariables(){
  idle->Register(&idle_Mobius_Mark);
  busy->Register(&busy_Mobius_Mark);
}

bool computerSAN::arrivalActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(idle_Mobius_Mark)) >=1));
  return NewEnabled;
}

double computerSAN::arrivalActivity::Rate(){
  return alpha;
  return 1.0;  // default rate if none is specified
}

double computerSAN::arrivalActivity::Weight(){ 
  return 1;
}

bool computerSAN::arrivalActivity::ReactivationPredicate(){ 
  return false;
}

bool computerSAN::arrivalActivity::ReactivationFunction(){ 
  return false;
}

double computerSAN::arrivalActivity::SampleDistribution(){
  return TheDistribution->Exponential(alpha);
}

double* computerSAN::arrivalActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int computerSAN::arrivalActivity::Rank(){
  return 1;
}

BaseActionClass* computerSAN::arrivalActivity::Fire(){
  (*(idle_Mobius_Mark))--;
  (*(busy_Mobius_Mark))++;
  return this;
}

/*======================completionActivity========================*/

computerSAN::completionActivity::completionActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("completion",1,Exponential, RaceEnabled, 2,1, false);
}

computerSAN::completionActivity::~completionActivity(){
  delete[] TheDistributionParameters;
}

void computerSAN::completionActivity::LinkVariables(){
  busy->Register(&busy_Mobius_Mark);
  idle->Register(&idle_Mobius_Mark);
}

bool computerSAN::completionActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(busy_Mobius_Mark)) >=1));
  return NewEnabled;
}

double computerSAN::completionActivity::Rate(){
  return beta;
  return 1.0;  // default rate if none is specified
}

double computerSAN::completionActivity::Weight(){ 
  return 1;
}

bool computerSAN::completionActivity::ReactivationPredicate(){ 
  return false;
}

bool computerSAN::completionActivity::ReactivationFunction(){ 
  return false;
}

double computerSAN::completionActivity::SampleDistribution(){
  return TheDistribution->Exponential(beta);
}

double* computerSAN::completionActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int computerSAN::completionActivity::Rank(){
  return 1;
}

BaseActionClass* computerSAN::completionActivity::Fire(){
  (*(busy_Mobius_Mark))--;
  (*(idle_Mobius_Mark))++;
  return this;
}

/*======================busy_failActivity========================*/

computerSAN::busy_failActivity::busy_failActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("busy_fail",2,Exponential, RaceEnabled, 2,1, false);
}

computerSAN::busy_failActivity::~busy_failActivity(){
  delete[] TheDistributionParameters;
}

void computerSAN::busy_failActivity::LinkVariables(){
  busy->Register(&busy_Mobius_Mark);
  failed->Register(&failed_Mobius_Mark);
}

bool computerSAN::busy_failActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(busy_Mobius_Mark)) >=1));
  return NewEnabled;
}

double computerSAN::busy_failActivity::Rate(){
  return lambda_w;
  return 1.0;  // default rate if none is specified
}

double computerSAN::busy_failActivity::Weight(){ 
  return 1;
}

bool computerSAN::busy_failActivity::ReactivationPredicate(){ 
  return false;
}

bool computerSAN::busy_failActivity::ReactivationFunction(){ 
  return false;
}

double computerSAN::busy_failActivity::SampleDistribution(){
  return TheDistribution->Exponential(lambda_w);
}

double* computerSAN::busy_failActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int computerSAN::busy_failActivity::Rank(){
  return 1;
}

BaseActionClass* computerSAN::busy_failActivity::Fire(){
  (*(busy_Mobius_Mark))--;
  (*(failed_Mobius_Mark))++;
  return this;
}

/*======================idle_failActivity========================*/

computerSAN::idle_failActivity::idle_failActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("idle_fail",3,Exponential, RaceEnabled, 2,1, false);
}

computerSAN::idle_failActivity::~idle_failActivity(){
  delete[] TheDistributionParameters;
}

void computerSAN::idle_failActivity::LinkVariables(){
  idle->Register(&idle_Mobius_Mark);
  failed->Register(&failed_Mobius_Mark);
}

bool computerSAN::idle_failActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(idle_Mobius_Mark)) >=1));
  return NewEnabled;
}

double computerSAN::idle_failActivity::Rate(){
  return lambda_i;
  return 1.0;  // default rate if none is specified
}

double computerSAN::idle_failActivity::Weight(){ 
  return 1;
}

bool computerSAN::idle_failActivity::ReactivationPredicate(){ 
  return false;
}

bool computerSAN::idle_failActivity::ReactivationFunction(){ 
  return false;
}

double computerSAN::idle_failActivity::SampleDistribution(){
  return TheDistribution->Exponential(lambda_i);
}

double* computerSAN::idle_failActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int computerSAN::idle_failActivity::Rank(){
  return 1;
}

BaseActionClass* computerSAN::idle_failActivity::Fire(){
  (*(idle_Mobius_Mark))--;
  (*(failed_Mobius_Mark))++;
  return this;
}

